<template>
	<div class="ext-codexexample-dialog-demo">
		<cdx-button
			class="ext-codexexample-dialog-demo__launch-button"
			@click="showDialog1 = true"
		>
			{{ $i18n( 'codexexample-app-launch-simple-dialog' ) }}
		</cdx-button>

		<cdx-button
			class="ext-codexexample-dialog-demo__launch-button"
			@click="showDialog2 = true"
		>
			{{ $i18n( 'codexexample-app-launch-complex-dialog' ) }}
		</cdx-button>

		<cdx-dialog
			v-model:open="showDialog1"
			:close-button-label="$i18n( 'codexexample-app-dialog-close-button-label' ).text()"
			:default-action="{
				label: $i18n( 'codexexample-app-simple-dialog-default-action-button' ).text() }"
			:title="$i18n( 'codexexample-app-simple-dialog-title' ).text()"
			@default="showDialog1 = false"
			@primary="showDialog1 = false"
		>
			<p>{{ $i18n( 'codexexample-app-simple-dialog-text' ) }}</p>
		</cdx-dialog>

		<teleport to="#ext-codexexample-teleport-target">
			<cdx-dialog
				v-model:open="showDialog2"
				class="ext-codexexample-dialog-demo__complex-dialog"
				:title="$i18n( 'codexexample-app-complex-dialog-heading' ).text()"
			>
				<template #header>
					<div>
						<h2>{{ $i18n( 'codexexample-app-complex-dialog-heading' ) }}</h2>
						<p>{{ $i18n( 'codexexample-app-complex-dialog-subheading' ) }}</p>
					</div>
					<div>
						<cdx-button
							class="ext-codexexample-dialog-demo__complex-dialog__close-button"
							weight="quiet"
							@click="showDialog2 = false;"
						>
							{{ $i18n( 'codexexample-app-dialog-close-button-label' ) }}
						</cdx-button>
					</div>
				</template>

				<p>{{ $i18n( 'codexexample-app-complex-dialog-slots-description' ) }}</p>
				<p>{{ $i18n( 'codexexample-app-complex-dialog-teleport-description' ) }}</p>

				<template #footer>
					<div class="ext-codexexample-dialog-demo__complex-dialog__footer-buttons">
						<cdx-button @click="showDialog2 = false">
							{{ $i18n( 'codexexample-app-dialog-close-button-label' ) }}
						</cdx-button>

						<cdx-button @click="showDialog2 = false">
							<cdx-icon :icon="cdxIconClose"></cdx-icon>
							{{ $i18n( 'codexexample-app-complex-dialog-close-button-with-icon' ) }}
						</cdx-button>
					</div>

					<cdx-button
						weight="primary"
						action="progressive"
						@click="showDialog2 = false"
					>
						{{ $i18n( 'codexexample-app-complex-dialog-primary-action-button' ) }}
					</cdx-button>
				</template>
			</cdx-dialog>
		</teleport>
	</div>
</template>

<script>
const { ref } = require( 'vue' );
const { CdxDialog, CdxButton, CdxIcon } = require( '../../codex.js' );

// Codex icons are available from ResourceLoader.
// To load only the icons you need, use a ResourceLoader callback (see
// https://www.mediawiki.org/wiki/Codex#Using_Codex_icons_in_MediaWiki_and_extensions
// or this extension's extension.json file).
const { cdxIconClose } = require( '../icons.json' );

/**
 * CdxDialog demo.
 */
// @vue/component
module.exports = {
	name: 'DialogDemo',
	components: {
		CdxDialog,
		CdxButton,
		CdxIcon
	},
	setup() {
		const showDialog1 = ref( false );
		const showDialog2 = ref( false );

		return {
			showDialog1,
			showDialog2,
			cdxIconClose
		};
	}
};
</script>

<style lang="less">
// To access Codex design tokens and mixins inside Vue files, import MediaWiki skin variables.
@import 'mediawiki.skin.variables.less';

.ext-codexexample-dialog-demo {
	&__launch-button {
		margin-bottom: @spacing-100;
	}

	&__complex-dialog {
		header {
			background-color: @background-color-progressive-subtle;
			display: flex;
			align-items: flex-start;
			justify-content: space-between;
			height: 200px;
			padding: @spacing-100;

			h2 {
				margin: 0;
				padding: 0;
				border: 0;
			}

			p {
				color: @color-subtle;
			}
		}

		footer {
			display: flex;
			align-items: baseline;
			justify-content: space-between;
			border-top: @border-style-base @border-width-base @border-color-subtle;
			padding: @spacing-50 @spacing-100;
		}
	}
}
</style>
